"""Coinbase Platform API

This is the OpenAPI 3.0 specification for the Coinbase Platform APIs, used in conjunction with the Coinbase Platform SDKs.

The version of the OpenAPI document: 0.0.1-alpha
Generated by OpenAPI Generator (https://openapi-generator.tech)

Do not edit the class manually.
"""

from typing import Annotated, Any

from pydantic import Field, StrictFloat, StrictInt, StrictStr, validate_call

from cdp.client.api_client import ApiClient, RequestSerialized
from cdp.client.api_response import ApiResponse
from cdp.client.models.create_smart_contract_request import CreateSmartContractRequest
from cdp.client.models.deploy_smart_contract_request import DeploySmartContractRequest
from cdp.client.models.smart_contract import SmartContract
from cdp.client.models.smart_contract_list import SmartContractList
from cdp.client.rest import RESTResponseType


class SmartContractsApi:
    """NOTE: This class is auto generated by OpenAPI Generator
    Ref: https://openapi-generator.tech

    Do not edit the class manually.
    """

    def __init__(self, api_client=None) -> None:
        if api_client is None:
            api_client = ApiClient.get_default()
        self.api_client = api_client

    @validate_call
    def create_smart_contract(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to deploy the smart contract from.")
        ],
        create_smart_contract_request: CreateSmartContractRequest,
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> SmartContract:
        """Create a new smart contract

        Create a new smart contract

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to deploy the smart contract from. (required)
        :type address_id: str
        :param create_smart_contract_request: (required)
        :type create_smart_contract_request: CreateSmartContractRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._create_smart_contract_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            create_smart_contract_request=create_smart_contract_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContract",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def create_smart_contract_with_http_info(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to deploy the smart contract from.")
        ],
        create_smart_contract_request: CreateSmartContractRequest,
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[SmartContract]:
        """Create a new smart contract

        Create a new smart contract

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to deploy the smart contract from. (required)
        :type address_id: str
        :param create_smart_contract_request: (required)
        :type create_smart_contract_request: CreateSmartContractRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._create_smart_contract_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            create_smart_contract_request=create_smart_contract_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContract",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def create_smart_contract_without_preload_content(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to deploy the smart contract from.")
        ],
        create_smart_contract_request: CreateSmartContractRequest,
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Create a new smart contract

        Create a new smart contract

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to deploy the smart contract from. (required)
        :type address_id: str
        :param create_smart_contract_request: (required)
        :type create_smart_contract_request: CreateSmartContractRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._create_smart_contract_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            create_smart_contract_request=create_smart_contract_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContract",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        return response_data.response

    def _create_smart_contract_serialize(
        self,
        wallet_id,
        address_id,
        create_smart_contract_request,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: dict[str, str] = {}

        _path_params: dict[str, str] = {}
        _query_params: list[tuple[str, str]] = []
        _header_params: dict[str, str | None] = _headers or {}
        _form_params: list[tuple[str, str]] = []
        _files: dict[str, str | bytes] = {}
        _body_params: bytes | None = None

        # process the path parameters
        if wallet_id is not None:
            _path_params["wallet_id"] = wallet_id
        if address_id is not None:
            _path_params["address_id"] = address_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if create_smart_contract_request is not None:
            _body_params = create_smart_contract_request

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(["application/json"])

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params["Content-Type"] = _content_type
        else:
            _default_content_type = self.api_client.select_header_content_type(["application/json"])
            if _default_content_type is not None:
                _header_params["Content-Type"] = _default_content_type

        # authentication setting
        _auth_settings: list[str] = []

        return self.api_client.param_serialize(
            method="POST",
            resource_path="/v1/wallets/{wallet_id}/addresses/{address_id}/smart_contracts",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def deploy_smart_contract(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to broadcast the transaction from.")
        ],
        smart_contract_id: Annotated[
            StrictStr,
            Field(description="The UUID of the smart contract to broadcast the transaction to."),
        ],
        deploy_smart_contract_request: DeploySmartContractRequest,
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> SmartContract:
        """Deploy a smart contract

        Deploys a smart contract, by broadcasting the transaction to the network.

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to broadcast the transaction from. (required)
        :type address_id: str
        :param smart_contract_id: The UUID of the smart contract to broadcast the transaction to. (required)
        :type smart_contract_id: str
        :param deploy_smart_contract_request: (required)
        :type deploy_smart_contract_request: DeploySmartContractRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._deploy_smart_contract_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            smart_contract_id=smart_contract_id,
            deploy_smart_contract_request=deploy_smart_contract_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContract",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def deploy_smart_contract_with_http_info(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to broadcast the transaction from.")
        ],
        smart_contract_id: Annotated[
            StrictStr,
            Field(description="The UUID of the smart contract to broadcast the transaction to."),
        ],
        deploy_smart_contract_request: DeploySmartContractRequest,
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[SmartContract]:
        """Deploy a smart contract

        Deploys a smart contract, by broadcasting the transaction to the network.

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to broadcast the transaction from. (required)
        :type address_id: str
        :param smart_contract_id: The UUID of the smart contract to broadcast the transaction to. (required)
        :type smart_contract_id: str
        :param deploy_smart_contract_request: (required)
        :type deploy_smart_contract_request: DeploySmartContractRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._deploy_smart_contract_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            smart_contract_id=smart_contract_id,
            deploy_smart_contract_request=deploy_smart_contract_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContract",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def deploy_smart_contract_without_preload_content(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to broadcast the transaction from.")
        ],
        smart_contract_id: Annotated[
            StrictStr,
            Field(description="The UUID of the smart contract to broadcast the transaction to."),
        ],
        deploy_smart_contract_request: DeploySmartContractRequest,
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Deploy a smart contract

        Deploys a smart contract, by broadcasting the transaction to the network.

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to broadcast the transaction from. (required)
        :type address_id: str
        :param smart_contract_id: The UUID of the smart contract to broadcast the transaction to. (required)
        :type smart_contract_id: str
        :param deploy_smart_contract_request: (required)
        :type deploy_smart_contract_request: DeploySmartContractRequest
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._deploy_smart_contract_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            smart_contract_id=smart_contract_id,
            deploy_smart_contract_request=deploy_smart_contract_request,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContract",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        return response_data.response

    def _deploy_smart_contract_serialize(
        self,
        wallet_id,
        address_id,
        smart_contract_id,
        deploy_smart_contract_request,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: dict[str, str] = {}

        _path_params: dict[str, str] = {}
        _query_params: list[tuple[str, str]] = []
        _header_params: dict[str, str | None] = _headers or {}
        _form_params: list[tuple[str, str]] = []
        _files: dict[str, str | bytes] = {}
        _body_params: bytes | None = None

        # process the path parameters
        if wallet_id is not None:
            _path_params["wallet_id"] = wallet_id
        if address_id is not None:
            _path_params["address_id"] = address_id
        if smart_contract_id is not None:
            _path_params["smart_contract_id"] = smart_contract_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter
        if deploy_smart_contract_request is not None:
            _body_params = deploy_smart_contract_request

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(["application/json"])

        # set the HTTP header `Content-Type`
        if _content_type:
            _header_params["Content-Type"] = _content_type
        else:
            _default_content_type = self.api_client.select_header_content_type(["application/json"])
            if _default_content_type is not None:
                _header_params["Content-Type"] = _default_content_type

        # authentication setting
        _auth_settings: list[str] = []

        return self.api_client.param_serialize(
            method="POST",
            resource_path="/v1/wallets/{wallet_id}/addresses/{address_id}/smart_contracts/{smart_contract_id}/deploy",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def get_smart_contract(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to fetch the smart contract for.")
        ],
        smart_contract_id: Annotated[
            StrictStr, Field(description="The UUID of the smart contract to fetch.")
        ],
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> SmartContract:
        """Get a specific smart contract deployed by address

        Get a specific smart contract deployed by address.

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to fetch the smart contract for. (required)
        :type address_id: str
        :param smart_contract_id: The UUID of the smart contract to fetch. (required)
        :type smart_contract_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._get_smart_contract_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            smart_contract_id=smart_contract_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContract",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def get_smart_contract_with_http_info(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to fetch the smart contract for.")
        ],
        smart_contract_id: Annotated[
            StrictStr, Field(description="The UUID of the smart contract to fetch.")
        ],
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[SmartContract]:
        """Get a specific smart contract deployed by address

        Get a specific smart contract deployed by address.

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to fetch the smart contract for. (required)
        :type address_id: str
        :param smart_contract_id: The UUID of the smart contract to fetch. (required)
        :type smart_contract_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._get_smart_contract_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            smart_contract_id=smart_contract_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContract",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def get_smart_contract_without_preload_content(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to fetch the smart contract for.")
        ],
        smart_contract_id: Annotated[
            StrictStr, Field(description="The UUID of the smart contract to fetch.")
        ],
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """Get a specific smart contract deployed by address

        Get a specific smart contract deployed by address.

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to fetch the smart contract for. (required)
        :type address_id: str
        :param smart_contract_id: The UUID of the smart contract to fetch. (required)
        :type smart_contract_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._get_smart_contract_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            smart_contract_id=smart_contract_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContract",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        return response_data.response

    def _get_smart_contract_serialize(
        self,
        wallet_id,
        address_id,
        smart_contract_id,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: dict[str, str] = {}

        _path_params: dict[str, str] = {}
        _query_params: list[tuple[str, str]] = []
        _header_params: dict[str, str | None] = _headers or {}
        _form_params: list[tuple[str, str]] = []
        _files: dict[str, str | bytes] = {}
        _body_params: bytes | None = None

        # process the path parameters
        if wallet_id is not None:
            _path_params["wallet_id"] = wallet_id
        if address_id is not None:
            _path_params["address_id"] = address_id
        if smart_contract_id is not None:
            _path_params["smart_contract_id"] = smart_contract_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(["application/json"])

        # authentication setting
        _auth_settings: list[str] = []

        return self.api_client.param_serialize(
            method="GET",
            resource_path="/v1/wallets/{wallet_id}/addresses/{address_id}/smart_contracts/{smart_contract_id}",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )

    @validate_call
    def list_smart_contracts(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to fetch the smart contracts for.")
        ],
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> SmartContractList:
        """List smart contracts deployed by address

        List all smart contracts deployed by address.

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to fetch the smart contracts for. (required)
        :type address_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._list_smart_contracts_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContractList",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        ).data

    @validate_call
    def list_smart_contracts_with_http_info(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to fetch the smart contracts for.")
        ],
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> ApiResponse[SmartContractList]:
        """List smart contracts deployed by address

        List all smart contracts deployed by address.

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to fetch the smart contracts for. (required)
        :type address_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._list_smart_contracts_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContractList",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        response_data.read()
        return self.api_client.response_deserialize(
            response_data=response_data,
            response_types_map=_response_types_map,
        )

    @validate_call
    def list_smart_contracts_without_preload_content(
        self,
        wallet_id: Annotated[
            StrictStr, Field(description="The ID of the wallet the address belongs to.")
        ],
        address_id: Annotated[
            StrictStr, Field(description="The ID of the address to fetch the smart contracts for.")
        ],
        _request_timeout: None
        | Annotated[StrictFloat, Field(gt=0)]
        | tuple[Annotated[StrictFloat, Field(gt=0)], Annotated[StrictFloat, Field(gt=0)]] = None,
        _request_auth: dict[StrictStr, Any] | None = None,
        _content_type: StrictStr | None = None,
        _headers: dict[StrictStr, Any] | None = None,
        _host_index: Annotated[StrictInt, Field(ge=0, le=0)] = 0,
    ) -> RESTResponseType:
        """List smart contracts deployed by address

        List all smart contracts deployed by address.

        :param wallet_id: The ID of the wallet the address belongs to. (required)
        :type wallet_id: str
        :param address_id: The ID of the address to fetch the smart contracts for. (required)
        :type address_id: str
        :param _request_timeout: timeout setting for this request. If one
                                 number provided, it will be total request
                                 timeout. It can also be a pair (tuple) of
                                 (connection, read) timeouts.
        :type _request_timeout: int, tuple(int, int), optional
        :param _request_auth: set to override the auth_settings for an a single
                              request; this effectively ignores the
                              authentication in the spec for a single request.
        :type _request_auth: dict, optional
        :param _content_type: force content-type for the request.
        :type _content_type: str, Optional
        :param _headers: set to override the headers for a single
                         request; this effectively ignores the headers
                         in the spec for a single request.
        :type _headers: dict, optional
        :param _host_index: set to override the host_index for a single
                            request; this effectively ignores the host_index
                            in the spec for a single request.
        :type _host_index: int, optional
        :return: Returns the result object.
        """
        _param = self._list_smart_contracts_serialize(
            wallet_id=wallet_id,
            address_id=address_id,
            _request_auth=_request_auth,
            _content_type=_content_type,
            _headers=_headers,
            _host_index=_host_index,
        )

        _response_types_map: dict[str, str | None] = {
            "200": "SmartContractList",
        }
        response_data = self.api_client.call_api(*_param, _request_timeout=_request_timeout)
        return response_data.response

    def _list_smart_contracts_serialize(
        self,
        wallet_id,
        address_id,
        _request_auth,
        _content_type,
        _headers,
        _host_index,
    ) -> RequestSerialized:
        _host = None

        _collection_formats: dict[str, str] = {}

        _path_params: dict[str, str] = {}
        _query_params: list[tuple[str, str]] = []
        _header_params: dict[str, str | None] = _headers or {}
        _form_params: list[tuple[str, str]] = []
        _files: dict[str, str | bytes] = {}
        _body_params: bytes | None = None

        # process the path parameters
        if wallet_id is not None:
            _path_params["wallet_id"] = wallet_id
        if address_id is not None:
            _path_params["address_id"] = address_id
        # process the query parameters
        # process the header parameters
        # process the form parameters
        # process the body parameter

        # set the HTTP header `Accept`
        if "Accept" not in _header_params:
            _header_params["Accept"] = self.api_client.select_header_accept(["application/json"])

        # authentication setting
        _auth_settings: list[str] = []

        return self.api_client.param_serialize(
            method="GET",
            resource_path="/v1/wallets/{wallet_id}/addresses/{address_id}/smart_contracts",
            path_params=_path_params,
            query_params=_query_params,
            header_params=_header_params,
            body=_body_params,
            post_params=_form_params,
            files=_files,
            auth_settings=_auth_settings,
            collection_formats=_collection_formats,
            _host=_host,
            _request_auth=_request_auth,
        )
